"""
Tools module to help with general tasks
"""

import os
import giturlparse
from giturlparse.parser import Parsed


def s2b(bstr: str) -> bool:
    if bstr is None:
        return False
    if isinstance(bstr, bool):
        return bstr
    if isinstance(bstr, str):
        return bstr.lower() in ['true', 't', '1', 'y', 'yes']
    return False


def s2b_env(env: str, default) -> bool:
    return s2b(os.getenv(env, default))


def dict_dig(dictionary: dict, path: list):
    for item in path:
        if item not in dictionary:
            return None
        dictionary = dictionary[item]
        if not isinstance(dictionary, dict):
            return dictionary
    return dictionary


def extract_git_info(url: str) -> Parsed:
    return giturlparse.parse(url=url)